# FOCAS Endpoint Properties

## `method` (string, enum, required)

The method to run on the device

This element must be one of the following enum values:

* `cnc_sysinfo`
* `cnc_statinfo2`
* `cnc_rdprgnum`
* `cnc_exeprgname`
* `cnc_rdopnlsgnl`
* `pmc_rdpmcrng`
* `cnc_rdspeed`
* `cnc_rdspload`
* `cnc_rdgcode`
* `program_download`

Example: `"cnc_sysinfo"`

## `interval` (integer)

The interval between reads (only for the subscribe operation)

Default: `1000`

Additional restrictions:

* Minimum: `500`

## `cronExpression` (string)

The Cron expression used to poll the endpoint. (For examples, see: <https://github.com/node-cron/node-cron>)

Examples: `"1,2,4,5 * * * *"`, `"1-5 * * * *"`, `"*/2 * * * *"`, `"* * * January,September Sunday"`

## `slctData` (integer)

Specify the data select flag (only applies for the cnc\_rdopnlsgnl method)

Default: `32767`

Additional restrictions:

* Maximum: `32767`

## `addressType` (integer)

Specify the identification code corresponding to the kind of the PMC address (only applies for the pmc\_rdpmcrng method)

Default: `0`

Additional restrictions:

* Maximum: `13`

## `dataType` (integer, enum)

Specify the type of the PMC data or CNC feed rate/spindle speed (only applies for the methods pmc\_rdpmcrng and cnc\_rdspeed), which can be byte (0), word (1), long (2), float32 (4) or float64 (5). float32 and float64 apply for 30i-B Series/0i-F/PMi-A only. For method cnc\_rdspeed valid values are 0 (feed rate), 1 (spindle speed), -1 (all)

This element must be one of the following enum values:

* `-1`
* `0`
* `1`
* `2`
* `4`
* `5`

Default: `0`

## `spindleNumber` (integer)

Specify spindle number to read. from 1 up to 8 for Series 30i, 0i-D/F. 1 up to 4 for Series 15/15i, 16i/18i/21i, 16i/18i/21i, 0i-A/B/C. And only number 1 for Power Mate i-D

Default: `1`

Additional restrictions:

* Minimum: `1`
* Maximum: `8`

## `type` (integer)

Specify the group of G code. Only applies for method cnc\_rdgcode. Series 15i: goes from 0 to 18,24,25,27/-1/100 to 103/-2. For Series 30i, 0i-D/F, PMi-A: goes from 0 to 36/-1/100 to 103/-2

Default: `-1`

Additional restrictions:

* Minimum: `-2`
* Maximum: `103`

## `block` (integer)

Specify the block to be read. 0 -> previus block, 1 -> active block, 2 -> next block. Only applies for method cnc\_rdgcode

Default: `1`

Additional restrictions:

* Maximum: `2`

## `numGcd` (integer)

number of G code data to be read. Only applies for method cnc\_rdgcode

Default: `1`

Additional restrictions:

* Minimum: `1`

## `addressStart` (integer)

Specify the start PMC address number (only applies for the pmc\_rdpmcrng method)

Default: `0`

## `addressEnd` (integer)

Specify the end PMC address number (only applies for the pmc\_rdpmcrng method)

Default: `0`

## `dataLength` (integer)

Specify the data block length (only applies for the pmc\_rdpmcrng method)

Default: `8`

Additional restrictions:

* Minimum: `8`


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.cybus.io/2-1-2/connectors/shop-floor-connectors/focas/focasendpoint.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
